<template>
  <b-modal
    hide-footer
    :id="`modal-project-${data && data.id}`"
    centered
    title="Add new project"
  >
    <form @submit.prevent="submitForm">
      <app-input v-model="name" placeholder="Name" />
      <b-button :disabled="name === ''" type="submit" variant="primary">
        {{ edit ? "Update" : "Create" }}</b-button
      >
    </form>
  </b-modal>
</template>

<script>
export default {
  props: {
    data: {
      type: Object,
      default: null,
    },
    edit: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      name: "",
    };
  },
  mounted() {
    console.log('ff')
  },
  methods: {
    async submitForm() {
      try {
        if (this.edit) {
          let payload = {
            id: this.data.id,
            name: this.name,
            projectGroupId: this.data.projectGroupId,
            position: this.data.position,
          };
          await this.$store.dispatch("task/edit", payload);
        } else {
          let payload = {
            id: this.data.id,
            project: {
              id: null,
              name: this.name,
              projectGroupId: this.data.id,
              position: null,
            },
          };
          await this.$store.dispatch("task/create", payload);
          this.name = "";
        }
        this.$bvToast.toast(
          this.edit
            ? "Project sucessfully updated"
            : "New project sucessfully created",
          {
            variant: "success",
            title: "Success",
            solid: true,
            toaster: "b-toaster-bottom-right",
          }
        );
        this.$bvModal.hide("modal-project-" + this.data.id);
      } catch (e) {
        console.log(e);
      }
    },
  },
  watch: {
    data: {
      handler(bef) {
        this.edit ? (this.name = bef.name) : (this.name = "");
      },
      deep: true,
    },
  },
};
</script>
